import { Data } from './index';
import * as _config from './config';
import * as _build from './build';
import * as _upgrade from './upgrade';
import * as vfs from './FileSystem';
import * as _watch from './watch';
export declare var config: typeof _config;
export declare var build: typeof _build;
export declare var upgrade: typeof _upgrade;
export declare var watch: typeof _watch;
export interface Data {
    resources: vfs.Dictionary;
    groups: {
        [groupName: string]: string[];
    };
    alias: {
        [aliasName: string]: string;
    };
}
export declare var data: Data;
export declare function print(): void;
export declare namespace ResourceConfig {
    var config: Data;
    var typeSelector: (path: string) => string;
    var mergeSelector: (path: string) => {
        path: string;
        alias: string;
    } | null;
    function addFile(r: any): void;
    function getFile(filename: string): vfs.File | undefined;
    function init(projectPath: any): Promise<{
        resourceRoot: string;
        resourceConfigFileName: any;
        typeSelector: any;
        mergeSelector: any;
    }>;
}
